<ui:composition xmlns:g="http://www.ihe.net/gazelle" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml">
    <!-- params:
          - managedBean : the name of the bean used to manage the display (inherit from AbstractValidatorBrowser) -->
    <!-- inserts:
          - additionalCriteria
          - adminButtons
          - actionButtons (val is the var to walk through the dataTable) -->
    <s:div id="globalDiv">
        <h:form id="criteriaForm">
            <!--<s:token allowMultiplePosts="true"/>-->
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{managedBean.filter.urlParameters}"/>
            <script>
                updateUrl("criteriaForm:filterUrlParameters");
                jq162("#criteriaForm\\:filterUrlParameters").bind('change',
                    function () {
                        updateUrl("criteriaForm:filterUrlParameters");
                    });
            </script>
            <s:div  styleClass="gzl-alert gzl-alert-orange" rendered="#{managedBean.emptyValidatorList}">
                <h:outputText value="#{messages['net.ihe.gazelle.xval.NoGazelleCrossValidatorHasBeenRegisteredYet']}"/>
                <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.CreateANewValidator']}"
                                   styleClass="gzl-btn-green" rendered="#{s:hasRole('admin_role') || s:hasRole('tests_editor_role')}"
                                   action="#{validatorAdministrationManager.createValidator()}"/>
            </s:div>
            <s:decorate template="/layout/panels/_panel_title_footer.xhtml"
                        rendered="#{not managedBean.emptyValidatorList}">
                <ui:define name="panel_title">
                    <h:outputText value="#{messages['net.ihe.gazelle.xval.SearchCriteria']}"/>
                </ui:define>
                <div class="row">
                    <div class="col-lg-6">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filterWidth" value="240"/>
                            <ui:param name="filter" value="#{managedBean.filter}"/>
                            <ui:param name="filterId" value="objectType"/>
                            <ui:param name="filterName" value="#{messages['net.ihe.gazelle.xval.ValidatedObject']}"/>
                            <ui:param name="filterForm" value="globalDiv"/>
                        </ui:include>
                    </div>
                    <div class="col-lg-6 form-horizontal">
                        <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                            <ui:param name="id" value="inheritInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.xval.InheritFrom']}</ui:define>
                            <h:inputText value="#{managedBean.filteredParent}" id="inheritInput"
                                         styleClass="form-control" style="width: 240px;">
                                <a4j:ajax event="keyup" render="globalDiv"/>
                            </h:inputText>
                        </ui:decorate>
                    </div>
                </div>
                <ui:insert name="additionalCriteria"/>
                <ui:define name="panel_footer">
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.ResetCriteria']}"
                                       actionListener="#{managedBean.resetFilter()}"
                                       render="globalDiv" styleClass="gzl-btn"/>
                    <ui:insert name="adminButtons"/>
                </ui:define>
            </s:decorate>
        </h:form>
        <s:decorate template="/layout/panels/_panel_title.xhtml" rendered="#{not managedBean.emptyValidatorList}"
                    id="validatorList">
            <ui:define name="panel_title">
                <h:outputText value="#{messages['net.ihe.gazelle.xval.GazelleCrossValidators_2']}"/>
            </ui:define>
            <h:form id="browseValidatorForm">
                #{dataTableStateHolder.setAscendingOn('name')}
                <rich:dataTable value="#{managedBean.gazelleCrossValidators}" var="val"
                                rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                render="ds" id="validatorTable">
                    <g:column sortBy="#{'name'}" sortOrder="#{dataTableStateHolder.sortOrders['name']}"
                              filterBy="#{'name'}" filterEvent="onkeyup">
                        <ui:define name="header">#{messages['net.ihe.gazelle.xval.Name']}</ui:define>
                        <h:outputText value="#{val.name}"/>
                    </g:column>
                    <g:column sortBy="#{'affinityDomain'}"
                              filterBy="#{'affinityDomain'}" filterEvent="onkeyup">
                        <ui:define name="header">#{messages['net.ihe.gazelle.xval.AffinityDomain_3']}</ui:define>
                        <h:outputText value="#{val.affinityDomain}"/>
                    </g:column>
                    <g:column filterBy="#{'version'}" filterEvent="onkeyup">
                        <ui:define name="header">#{messages['net.ihe.gazelle.xval.Version']}</ui:define>
                        <h:outputText value="#{val.version}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.xval.OID']}</ui:define>
                        <h:outputText value="#{val.oid}"/>
                    </g:column>
                    <g:column rendered="#{displayStatusColumn}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.xval.Status']}</ui:define>
                        <h:outputText value="#{val.status.value}" styleClass="gzl-label gzl-label-green"
                                      rendered="#{val.isAvailable()}"/>
                        <h:outputText value="#{val.status.value}" styleClass="gzl-label gzl-label-blue"
                                      rendered="#{val.isUnderDevelopment()}"/>
                        <h:outputText value="#{val.status.value}" styleClass="gzl-label gzl-label-red"
                                      rendered="#{val.isDeprecated()}"/>
                        <h:outputText value="#{val.status.value}" styleClass="gzl-label gzl-label-orange"
                                      rendered="#{val.isUnderMaintenance()}"/>
                    </g:column>
                    <g:column sortBy="#{'lastModifiedDate'}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.xval.LastModifiedOn']}</ui:define>
                        <g:date date="true" time="true" value="#{val.lastModifiedDate}" tooltip="false"/>
                    </g:column>
                    <g:column sortBy="#{'lastModifier'}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.xval.LastModifiedBy']}</ui:define>
                        <h:outputText value="#{val.lastModifier}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.xval.Actions']}</ui:define>
                        <div class="gzl-never-wrap">
                            <g:imagelink value="#{val}" fontIcon="fa fa-search gzl-text-blue" styleClass="action"/>
                            <ui:insert name="actionButtons"/>
                        </div>
                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="ds"/>
                            <ui:param name="dataTableId" value="validatorTable"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
            </h:form>
        </s:decorate>
    </s:div>
</ui:composition>
